#if !defined(AFX_SDR14XCTL_H__65B4D560_E362_45E2_AEDC_8CC51AA03CDC__INCLUDED_)
#define AFX_SDR14XCTL_H__65B4D560_E362_45E2_AEDC_8CC51AA03CDC__INCLUDED_
//////////////////////////////////////////////////////////////////////
// Copyright 2003.    Moe Wheatley AE4JY  <http://www.moetronix.com>
//
//This program is free software; you can redistribute it and/or
//modify it how ever you wish.  Its primary goal is to provide an
// example for 3rd party software developers.  Support will be limited
// depending on my available time.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
////////////////////////////////////////////////////////////////////////

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// SDR14XCtl.h : Declaration of the CSDR14XCtrl ActiveX Control class.

#include "USBio.h"
#include "AscpDefs.h"	//local copy of ASCP defs
#include "cfft.h"

#define MSG_DATARDY 1000	//local user messages for event firing
#define MSG_STATUSCHNG 1001
#define MSG_AUXDATARDY 1002

#define STATUS_NOTCONNECTED 0	//SDR-14,IQ status codes
#define STATUS_IDLECONNECTED 1
#define STATUS_RUNNING 2
#define STATUS_ERROR 3
#define STATUS_ADOVERLOAD 4		//IQ only

#define AUX_QUE_LENGTH 1024		//keep power of 2 for modulo wrap around
#define AUX_QUE_MODMASK (AUX_QUE_LENGTH-1)

#define SDRTYPE_14 0
#define SDRTYPE_IQ 1

//(dec) 9-Oct-04 Uncomment this to fix the OLEMISC_INVISIBLEATRUNTIME problem with VB
#define	OLEMISC_INVISIBLEATRUNTIME_FIX


/////////////////////////////////////////////////////////////////////////////
// CSDR14XCtrl : See SDR14XCtl.cpp for implementation.

class CSDR14XCtrl : public COleControl
{
	DECLARE_DYNCREATE(CSDR14XCtrl)


// Constructor
public:
	CSDR14XCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSDR14XCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

// Implementation
protected:
	~CSDR14XCtrl();

	DECLARE_OLECREATE_EX(CSDR14XCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CSDR14XCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CSDR14XCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CSDR14XCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CSDR14XCtrl)
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CSDR14XCtrl)
	afx_msg long GetClockFrequency();
	afx_msg void SetClockFrequency(long nNewValue);
	afx_msg BSTR GetDeviceName();
	afx_msg void SetDeviceName(LPCTSTR lpszNewValue);
	afx_msg short GetFirmwareRevision();
	afx_msg void SetFirmwareRevision(short nNewValue);
	afx_msg short GetHFgain();
	afx_msg void SetHFgain(short nNewValue);
	afx_msg short GetIFfilter();
	afx_msg void SetIFfilter(short nNewValue);
	afx_msg short GetInputSource();
	afx_msg void SetInputSource(short nNewValue);
	afx_msg short GetInterfaceVersion();
	afx_msg void SetInterfaceVersion(short nNewValue);
	afx_msg long GetNCOfrequency();
	afx_msg void SetNCOfrequency(long nNewValue);
	afx_msg BSTR GetSerialNumber();
	afx_msg void SetSerialNumber(LPCTSTR lpszNewValue);
	afx_msg short GetIFgain();
	afx_msg void SetIFgain(short nNewValue);
	afx_msg long GetSampleRate();
	afx_msg void SetSampleRate(long nNewValue);
	afx_msg short GetBootRevision();
	afx_msg void SetBootRevision(short nNewValue);
	afx_msg double GetIQOffset();
	afx_msg void SetIQOffset(double newValue);
	afx_msg void Stop();
	afx_msg void CloseUartPort();
	afx_msg void CloseSpiPort();
	afx_msg void CloseI2CPort();
	afx_msg void Start(short Blocks, short Mode);
	afx_msg long GetLongData(long FAR* DataArray);
	afx_msg long GetDoubleData(double FAR* DataArray);
	afx_msg long GetIntegerData(short FAR* DataArray);
	afx_msg short GetUartData(short FAR* UartRxArray);
	afx_msg void OpenI2CPort(short AdrWidth);
	afx_msg void OpenSpiPort(short ClkPolarity);
	afx_msg void OpenUartPort(long BaudRate, short Parity, BOOL FlowControl);
	afx_msg void SendUartData(short FAR* UartTxArray, short NumDataItems);
	afx_msg void Send6620RawCmd(short Address, short D0, short D1, short D2, short D3, short D4);
	afx_msg void SendI2CData(short FAR* TxDataArray, short NumDataItems);
	afx_msg void SendSpiData(long Data32High, long Data32Low, short NumberBits);
	afx_msg BOOL GetFftScreenData(long PlotHeght, long PlotWidth, double MaxdB, double MindB, long StartFreq, long EndFreq, long FAR* PlotBuf);
	afx_msg BOOL GetFftDoubleData(double FAR* DataArray);
	afx_msg void SetupFFT(long FftPoints, short Fftaverages, BOOL FftInverted);
	afx_msg void ResetFftAverage();
	afx_msg void InitControl();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CSDR14XCtrl)
	void FireStatusChange(long Status)
		{FireEvent(eventidStatusChange,EVENT_PARAM(VTS_I4), Status);}
	void FireDataRdy(long BlocksAvailable)
		{FireEvent(eventidDataRdy,EVENT_PARAM(VTS_I4), BlocksAvailable);}
	void FireUartDataRdy()
		{FireEvent(eventidUartDataRdy,EVENT_PARAM(VTS_NONE));}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CSDR14XCtrl)
	dispidClockFrequency = 1L,
	dispidDeviceName = 2L,
	dispidFirmwareRevision = 3L,
	dispidHFgain = 4L,
	dispidIFfilter = 5L,
	dispidInputSource = 6L,
	dispidInterfaceVersion = 7L,
	dispidNCOfrequency = 8L,
	dispidSerialNumber = 9L,
	dispidIFgain = 10L,
	dispidSampleRate = 11L,
	dispidBootRevision = 12L,
	dispidIQOffset = 13L,
	dispidStop = 14L,
	dispidCloseUartPort = 15L,
	dispidCloseSpiPort = 16L,
	dispidCloseI2CPort = 17L,
	dispidStart = 18L,
	dispidGetLongData = 19L,
	dispidGetDoubleData = 20L,
	dispidGetIntegerData = 21L,
	dispidGetUartData = 22L,
	dispidOpenI2CPort = 23L,
	dispidOpenSpiPort = 24L,
	dispidOpenUartPort = 25L,
	dispidSendUartData = 26L,
	dispidSend6620RawCmd = 27L,
	dispidSendI2CData = 28L,
	dispidSendSpiData = 29L,
	dispidGetFftDoubleData = 31L,
	dispidSetupFFT = 32L,
	dispidResetFftAverage = 33L,
	dispidInitControl = 34L,
	eventidStatusChange = 1L,
	eventidDataRdy = 2L,
	eventidUartDataRdy = 3L,
	//}}AFX_DISP_ID
	};
	// need to be public for USB thread access
	BOOL m_ThreadRunning;
	int m_SDRtype;
	CWinThread *m_pUSBThread;
	CWinThread *m_pFIFOThread;
	CUSBio m_USBio;
	void ParseASCPmsg(ASCPstruct* pASCPmsg);
	void ErrorStop();
protected:
	afx_msg LRESULT OnDataRdy(UINT p1, LONG p2);
	afx_msg LRESULT OnAuxDataRdy(UINT length, LONG p2);
	afx_msg LRESULT OnStatusChange(UINT status, LONG p2);

#ifdef OLEMISC_INVISIBLEATRUNTIME_FIX
	//(dec) 9-Oct-04 Added to fix OLEMISC_INVISIBLEATRUNTIME problem with VB
	BOOL	m_bDrawCtl;
#endif

private:
// internal helper functions
	static UINT USBThreadProc(LPVOID pParam);	//must be static since is thread
	static UINT FIFOThreadProc(LPVOID pParam);	//must be static since is thread
	void EndThreads();
	void SetupDataBuffers( int blocks);
	double CalcOffsetIQ();
	void ReadSDRIQClockFrequency();
	void WriteSDRIQClockFrequency();
//  property variables
	short m_BootRevision;
	short m_FirmwareRevision;
	short m_HFgain;	
	short m_InterfaceVersion;
	short m_IFfilter;
	short m_IFgain;
	short m_InputSource;
	short m_TestModeChannel;
	long m_NCOfrequency;
	long m_ClockFrequency;
	long m_SampleRate;
	double m_IQOffset;
	CString m_DeviceName;
	CString m_SerialNumber;
//	local variables
	BOOL m_Complex;		//whether data is complex or real
	BOOL m_FFTInvert;
	BOOL m_ADOverload;
	unsigned char m_AuxRxQue[AUX_QUE_LENGTH];
	short m_SPIClockPol;
	short m_NumberOfSPIBits;
	short m_CaptureMode;
	int m_RCFTaps;
	int m_FFTsize;
	int m_FFTAve;
	int m_BlockCount;
	int m_NumberOfBlocks;
	int	m_DataAckCounter;
	int m_DataAckCounterLoadVal;
	int m_AuxRxHead;	//UART Rx queue pointers
	int m_AuxRxTail;
	int m_WindowsMsgCount;		//keep track of how many data msgs were sent and not responded to

	short** m_pDataBuffer;
	int m_FifoHead;
	int m_FifoTail;
	int m_FifoFFTTail;

	ASCPstruct m_ASCPmsg;
	ASCPstruct m_ASCPackmsg;
	Cxfft m_FFT;
	CRITICAL_SECTION m_CriticalSection;	//for keeping threads from stomping on each other
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SDR14XCTL_H__65B4D560_E362_45E2_AEDC_8CC51AA03CDC__INCLUDED)
